<template>
  <v-app>
    <!-- spinner -->
    <div class="text-center">
      <v-dialog v-model="dialog_loader" hide-overlay persistent width="300">
        <v-card color="#428bca" dark>
          <v-card-text class="text-center" style="color: white">
            Wait . . .
            <v-progress-linear
              indeterminate
              color="white"
              class="mb-0"
            ></v-progress-linear>
          </v-card-text>
        </v-card>
      </v-dialog>
    </div>
    <!-- spinner -->

    <!-- ภาพรวมรายปี -->
    <v-container>
      <v-card>
        <v-container>
          <v-card-title>
            <v-row>
              <v-col cols="12" sm="8" md="8" lg="8">
                <span style="font-size: 24px" v-if="all_year.length != 0">
                  ภาพรวมรายปี
                  <v-icon style="font-size: 24px">mdi-chevron-right</v-icon>
                  {{ select_year }}
                </span>
                <v-divider style="width: 70%" v-if="all_year.length != 0"></v-divider>
              </v-col>
              <v-col cols="12" sm="4" md="4">
                <v-select
                  type="year"
                  class="pa-0"
                  :items="items"
                  v-model="select_year"
                  label="select year for filter"
                  dense
                  outlined
                ></v-select>
              </v-col>
              <v-col cols="12" sm="8" md="8" class="py-0 mt-0"
                ><div id="chart" v-if="all_year.length != 0">
                  <apexchart
                    type="bar"
                    height="300"
                    :options="chartOptions"
                    :series="series"
                  ></apexchart>
                </div>
                <div v-else class="mb-12 text-center">
                  <p style="font-size: 20px">ไม่พบข้อมูลภาพรวมรายปี {{ select_year }} </p>
                </div>
              </v-col>
              <v-col cols="12" sm="4" md="4" class="py-0 mt-0" v-if="all_year.length != 0">
                <v-icon style="font-size: 10px" color="success">mdi-circle</v-icon>
                &nbsp;
                <span style="font-size: 16px">
                  Package Name : {{ package_hospital.datapackage[0].package_name }}
                </span>
                <br />
                <v-icon style="font-size: 10px" color="primary">mdi-circle</v-icon>
                &nbsp;
                <span style="font-size: 16px" v-if="package_hospital.datapackage[0].flim_upload !='unlimited'">
                  Limit Film :
                  {{ package_hospital.datapackage[0].flim_upload / 12 }} / เดือน
                </span>
                <span style="font-size: 16px" v-else>
                  Limit Film : unlimited
                </span>
                <br />
                <v-icon style="font-size: 10px" color="error">
                  mdi-circle
                </v-icon>
                &nbsp;
                <span style="font-size: 16px">
                  Expired : {{ moment(package_hospital.datapackage[0].enddate).format("DD /MM /YYYY")}}
                </span>
              </v-col>
            </v-row>
          </v-card-title>
        </v-container>
      </v-card>
    </v-container>
    <!-- ภาพรวมรายปี -->
  </v-app>
</template>

<script>
import moment from "moment";
export default {
  data() {
    return {
      api: process.env.VUE_APP_API,
      moment,
      dialog_loader: false,
      items: [],
      select_year: new Date().toISOString().substr(0, 10),
      series: [
        {
          name: "used",
          data: []
        }
      ],
      chartOptions: {
        annotations: {
          points: [
            {
              x: "Bananas",
              seriesIndex: 0,
              label: {
                borderColor: "#775DD0",
                offsetY: 0,
                style: {
                  color: "#fff",
                  background: "#775DD0"
                },
                text: "Bananas are good"
              }
            }
          ]
        },
        chart: {
          height: 300,
          type: "bar"
        },
        plotOptions: {
          bar: {
            columnWidth: "10%",
            endingShape: "rounded",
            dataLabels: {
              position: "top"
            }
          }
        },
        dataLabels: {
          formatter: function(val) {
            return val;
          },
          enabled: true,
          offsetY: -20,
          style: {
            fontSize: "12px",
            colors: ["#304758"]
          }
        },
        stroke: {
          width: 0
        },

        grid: {
          row: {
            colors: ["#fff", "#f2f2f2"]
          }
        },
        xaxis: {
          labels: {
            rotate: -45
          },
          categories: []
          //   tickPlacement: "on",
        },
        yaxis: {
          title: {
            text: "U S E  F I L M"
          }
        },
        fill: {
          show: true,
          colors: ["#1DE9B6"]
        }
      },
      all_year: [],
      package: {},
      chart: [],
      data_number_year: [1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12],
      count_number: 0,
      array_count_data: []
    };
  },
  watch: {
    select_year(val) {
      console.log("select_year", val);
      this.get_year_dashboard();
    }
  },
  mounted() {
    console.log("api:", this.api)
    this.count_number = 0;
    this.select_year = moment(this.select_year).format("YYYY");
    let array_year = [];
    for (let index = this.select_year - 3; index <= this.select_year; index++) {
      array_year.push(String(index));
    }
    array_year.sort();
    array_year.sort(function(a, b) {
      return b - a;
    });
    this.items = array_year;
    this.select_year = moment(this.select_year).format("YYYY");
    this.get_year_dashboard();
  },
  methods: {
    get_year_dashboard() {
      this.dialog_loader = true;
      this.axios
        .get(
          process.env.VUE_APP_API + "/api/v3/film_overview/Year_filmoverview",
          {
            params: {
              hospital_id: this.$cookies.get("info_login").hospital_id,
              user_id: this.$cookies.get("info_login").user_id,
              date_time: this.select_year
            },
            headers: {
              Authorization: this.$cookies.get("info_login").session_id
            }
          }
        )
        .then(response => {
          console.log("response-year", response);
          var count = 0;
          this.chart = [];
          this.array_count_data = [];
          this.count_number = 0;
          this.package_hospital = response.data.data;
          console.log(this.package_hospital);
          this.all_year = response.data.data.dashborad;
          for (let i = 0; i < response.data.data.dashborad.length; i++) {
            //  console.log(moment(this.all_year[i].upload_datetime).format("MM"))
            if (this.chart == 0) {
              this.chart.push(moment(this.all_year[i].upload_datetime).format("MMM"));
            } else {
              //  console.log("type",typeof(moment(this.all_year[i].upload_datetime).format("MM")))
              //  console.log("chart",this.chart[i])
              if (this.chart[i] == undefined) {
                if (this.chart[count] != moment(this.all_year[i].upload_datetime).format("MMM")) {
                  this.chart.push(moment(this.all_year[i].upload_datetime).format("MMM"));
                  count = count + 1;
                }
              } else {
                console.log("else");
              }
            }
          }
          for (let index = 0; index < response.data.data.dashborad.length; index++) {
            console.log(moment(response.data.data.dashborad[index].upload_datetime).format("M"));
            this.array_count_data.push(moment(response.data.data.dashborad[index].upload_datetime).format("M"));
          }
          console.log("array_count_data", this.array_count_data);
          var counts = {};
          this.array_count_data.forEach(function(x) {
            counts[x] = (counts[x] || 0) + 1;
          });
          console.log("object-counts", counts);
          const myArr = Object.values(counts);
          console.log("data", myArr);
          this.series.data = myArr;
          var allMonths = [
            "Jan",
            "Feb",
            "Mar",
            "Apr",
            "May",
            "Jun",
            "Jul",
            "Aug",
            "Sep",
            "Oct",
            "Nov",
            "Dec"
          ];
          var chart_data = this.chart;
          chart_data.sort(function(a, b) {
            return allMonths.indexOf(a) - allMonths.indexOf(b);
          });
          console.log("chart_data", chart_data);
          // console.log("chart",this.chart)
          (this.series = [
            {
              name: "used",
              data: myArr
            }
          ]),
            (this.chartOptions = {
              ...this.chartOptions,
              ...{
                xaxis: {
                  categories: chart_data
                }
              }
            });
          this.dialog_loader = false;
        })
        .catch(error => {
          this.dialog_loader = false;
          console.log("error", error);
        });
    }
  }
};
</script>

<style></style>
